#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
}
Object.defineProperty(exports, "__esModule", { value: true });
var child_process_1 = require("child_process");
var copy_template_dir_1 = __importDefault(require("copy-template-dir"));
var path_1 = require("path");
main();
function main() {
    var input = path_1.join(__dirname, 'template');
    var output = process.cwd();
    var email = $('npm config get init.author.email');
    enforce(email, 'npm config set init.author.email [email]');
    var license = $('npm config get init.license') || 'MIT';
    var name = $('npm config get init.author.name');
    enforce(name, 'npm config set init.author.name [full name]');
    var username = $('git config --global github.user');
    enforce(username, 'git config --add github.user [username]');
    var vars = {
        email: email,
        license: license,
        name: name,
        projectname: path_1.basename(output),
        username: username
    };
    copy_template_dir_1.default(input, output, vars, function (err) {
        if (err) {
            throw err;
        }
        try {
            $('yarn install');
        }
        catch (e) {
            $('npm install');
        }
    });
}
function enforce(value, command) {
    if (value === '') {
        throw 'Please run: "' + command + '"';
    }
}
function $(command) {
    try {
        var _ = child_process_1.execSync(command, { cwd: process.cwd() });
        return _.toString().trim();
    }
    catch (e) {
        return '';
    }
}
//# sourceMappingURL=index.js.map